#define OPTIMIZE_ROM_CALLS
#define RETURN_VALUE
#define MIN_AMS 101

#include <tigcclib.h>
typedef unsigned long long VLI;	//very long integer

VLI GCD(VLI m, VLI n)
{
	VLI tmp;
	while(m)
	{
		tmp = m;
		m = n % m;
		n = tmp;
	}       
	return n;
}

void _main(void)
{
	//Initialize argument pointer
	ESI q = top_estack;
	
	//Seperate the numerator (a) and denominator (b) from the passed argument
	//This both (1) simplifies the fraction and (2) makes sure that the denominator is neither zero nor one
	VLI a = GetIntArg(q);
	q++;
	VLI b = GetIntArg(q);
	
	//Ensure fraction is valid
	//Denominator is neither 0 nor 1
	if(b==0)
	{
		ST_helpMsg("Input must be a non-integer fraction.");
		push_quantum(NOTHING_TAG);
		return;
	}
	
	//Remove whole numbers (i.e. take fractional part of argument)
	VLI w = a/b;	//integer part of the fraction
	a -= b*w;

	//Reduce the fraction
	VLI g=GCD(a,b);
	a /= g;
	b /= g;
	
	//Push the fraction to the stack
	//Method 1 (returns 3/7 + 8)
	push_longlongint(w);
	push_longlongint(a);
	push_longlongint(b);
	push_quantum_pair(DIV_TAG, ADD_TAG);
	
	//Method 2 (returns 8 + 3/7; takes more memory)
	/*push_longlongint(a);
	push_longlongint(b);
	push_quantum(DIV_TAG);
	push_longlongint(w);
	push_quantum(ADD_TAG);*/
}
